com.hazelcast.config

## Class MapConfig

- java.lang.Object
- - com.hazelcast.config.MapConfig

- All Implemented Interfaces:
    NamedConfig, DataSerializable, IdentifiedDataSerializable, com.hazelcast.nio.serialization.impl.Versioned, SplitBrainMergeTypeProvider
  Direct Known Subclasses:
    MapConfigReadOnly

      public class MapConfig
      extends Object
      implements SplitBrainMergeTypeProvider, IdentifiedDataSerializable, com.hazelcast.nio.serialization.impl.Versioned, NamedConfig

  Contains the configuration for an `IMap`.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `DEFAULT_BACKUP_COUNT` The default number of backups
    `static CacheDeserializedValues` | `DEFAULT_CACHED_DESERIALIZED_VALUES` We want to cache values only when an index is defined.
    `static int` | `DEFAULT_EVICTION_PERCENTAGE` The number of default eviction percentage
    `static EvictionPolicy` | `DEFAULT_EVICTION_POLICY` Default policy for eviction.
    `static InMemoryFormat` | `DEFAULT_IN_MEMORY_FORMAT` Default In-Memory format is binary.
    `static String` | `DEFAULT_MAP_MERGE_POLICY` Default policy for merging.
    `static int` | `DEFAULT_MAX_IDLE_SECONDS` The number of default time to wait eviction in seconds.
    `static MetadataPolicy` | `DEFAULT_METADATA_POLICY` Default metadata policy
    `static long` | `DEFAULT_MIN_EVICTION_CHECK_MILLIS` Minimum time in milliseconds which should pass before asking if a partition of this map is evictable or not.
    `static int` | `DEFAULT_TTL_SECONDS` The number of default Time to Live in seconds.
    `static int` | `MAX_BACKUP_COUNT` The maximum number of backups
    `static int` | `MAX_EVICTION_PERCENTAGE` The number of maximum eviction percentage
    `static int` | `MIN_BACKUP_COUNT` The minimum number of backups
    `static int` | `MIN_EVICTION_PERCENTAGE` The number of minimum eviction percentage

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MapConfig()`
    `MapConfig(MapConfig config)`
    `MapConfig(String name)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `MapConfig` | `addEntryListenerConfig(EntryListenerConfig listenerConfig)`
    `MapConfig` | `addMapAttributeConfig(MapAttributeConfig mapAttributeConfig)`
    `MapConfig` | `addMapIndexConfig(MapIndexConfig mapIndexConfig)`
    `MapConfig` | `addMapPartitionLostListenerConfig(MapPartitionLostListenerConfig listenerConfig)`
    `MapConfig` | `addQueryCacheConfig(QueryCacheConfig queryCacheConfig)` Adds a new `QueryCacheConfig` to this `MapConfig`.
    `boolean` | `equals(Object o)`
    `MapConfigReadOnly` | `getAsReadOnly()` Deprecated. this method will be removed in 4.0; it is meant for internal usage only
    `int` | `getAsyncBackupCount()` Returns the asynchronous backup count for this `IMap`.
    `int` | `getBackupCount()` Returns the backupCount for this `IMap`
    `CacheDeserializedValues` | `getCacheDeserializedValues()` Get current value cache settings
    `List<EntryListenerConfig>` | `getEntryListenerConfigs()`
    `int` | `getEvictionPercentage()` Deprecated. As of version 3.7, eviction mechanism changed. It uses a probabilistic algorithm based on sampling. Please see documentation for further details.
    `EvictionPolicy` | `getEvictionPolicy()` Returns the `EvictionPolicy`.
    `int` | `getFactoryId()` Returns DataSerializableFactory factory ID for this class.
    `HotRestartConfig` | `getHotRestartConfig()` Gets the `HotRestartConfig` for this `MapConfig`
    `int` | `getId()` Returns type identifier for this class.
    `InMemoryFormat` | `getInMemoryFormat()` Returns the data type that will be used for storing records.
    `List<MapAttributeConfig>` | `getMapAttributeConfigs()`
    `MapEvictionPolicy` | `getMapEvictionPolicy()` Returns custom eviction policy if it is set otherwise returns `null`.
    `List<MapIndexConfig>` | `getMapIndexConfigs()`
    `MapStoreConfig` | `getMapStoreConfig()` Returns the map store configuration
    `int` | `getMaxIdleSeconds()` Returns the maximum number of seconds for each entry to stay idle in the map.
    `MaxSizeConfig` | `getMaxSizeConfig()`
    `String` | `getMergePolicy()` Deprecated. since 3.10, please use `getMergePolicyConfig()` and `MergePolicyConfig.getPolicy()`
    `MergePolicyConfig` | `getMergePolicyConfig()` Gets the `MergePolicyConfig` for this map.
    `MetadataPolicy` | `getMetadataPolicy()` Returns `MetadataPolicy` for this map.
    `long` | `getMinEvictionCheckMillis()` Deprecated. As of version 3.7, eviction mechanism changed. It uses a probabilistic algorithm based on sampling. Please see documentation for further details.
    `String` | `getName()` Returns the name of this `IMap`
    `NearCacheConfig` | `getNearCacheConfig()` Returns the Near Cache configuration
    `PartitioningStrategyConfig` | `getPartitioningStrategyConfig()`
    `List<MapPartitionLostListenerConfig>` | `getPartitionLostListenerConfigs()`
    `Class` | `getProvidedMergeTypes()`
    `List<QueryCacheConfig>` | `getQueryCacheConfigs()` Returns all `QueryCacheConfig` instances defined on this `MapConfig`.
    `String` | `getQuorumName()`
    `int` | `getTimeToLiveSeconds()` Returns the maximum number of seconds for each entry to stay in the map.
    `int` | `getTotalBackupCount()` Returns the total number of backups: backupCount plus asyncBackupCount.
    `WanReplicationRef` | `getWanReplicationRef()` Gets the WAN target replication reference.
    `int` | `hashCode()`
    `boolean` | `isNearCacheEnabled()` Checks if Near Cache is enabled.
    `boolean` | `isOptimizeQueries()` Deprecated. use `getQueryCacheConfigs()` instead
    `boolean` | `isReadBackupData()` Checks if read-backup-data (reading local backup entries) is enabled for this map.
    `boolean` | `isStatisticsEnabled()` Checks if statistics are enabled for this map.
    `void` | `readData(ObjectDataInput in)` Reads fields from the input stream
    `MapConfig` | `setAsyncBackupCount(int asyncBackupCount)` Sets the number of asynchronous backups.
    `MapConfig` | `setBackupCount(int backupCount)` Number of synchronous backups.
    `MapConfig` | `setCacheDeserializedValues(CacheDeserializedValues cacheDeserializedValues)` Configure de-serialized value caching.
    `MapConfig` | `setEntryListenerConfigs(List<EntryListenerConfig> listenerConfigs)`
    `MapConfig` | `setEvictionPercentage(int evictionPercentage)` Deprecated. As of version 3.7, eviction mechanism changed. It uses a probabilistic algorithm based on sampling. Please see documentation for further details
    `MapConfig` | `setEvictionPolicy(EvictionPolicy evictionPolicy)` Sets the `EvictionPolicy`.
    `MapConfig` | `setHotRestartConfig(HotRestartConfig hotRestartConfig)` Sets the `HotRestartConfig` for this `MapConfig`
    `MapConfig` | `setInMemoryFormat(InMemoryFormat inMemoryFormat)` Binary type that will be used for storing records.
    `MapConfig` | `setMapAttributeConfigs(List<MapAttributeConfig> mapAttributeConfigs)`
    `MapConfig` | `setMapEvictionPolicy(MapEvictionPolicy mapEvictionPolicy)` Sets custom eviction policy implementation for this map.
    `MapConfig` | `setMapIndexConfigs(List<MapIndexConfig> mapIndexConfigs)`
    `MapConfig` | `setMapStoreConfig(MapStoreConfig mapStoreConfig)` Sets the map store configuration
    `MapConfig` | `setMaxIdleSeconds(int maxIdleSeconds)` Maximum number of seconds for each entry to stay idle in the map.
    `MapConfig` | `setMaxSizeConfig(MaxSizeConfig maxSizeConfig)`
    `MapConfig` | `setMergePolicy(String mergePolicy)` Deprecated. since 3.10, please use `setMergePolicyConfig(MergePolicyConfig)`
    `MapConfig` | `setMergePolicyConfig(MergePolicyConfig mergePolicyConfig)` Sets the `MergePolicyConfig` for this map.
    `MapConfig` | `setMetadataPolicy(MetadataPolicy metadataPolicy)` Sets the metadata policy.
    `MapConfig` | `setMinEvictionCheckMillis(long minEvictionCheckMillis)` Deprecated. As of version 3.7, eviction mechanism changed. It uses a probabilistic algorithm based on sampling. Please see documentation for further details.
    `MapConfig` | `setName(String name)` Sets the name of the `IMap`
    `MapConfig` | `setNearCacheConfig(NearCacheConfig nearCacheConfig)` Sets the Near Cache configuration
    `MapConfig` | `setOptimizeQueries(boolean optimizeQueries)` Deprecated. use `setCacheDeserializedValues(CacheDeserializedValues)` instead
    `MapConfig` | `setPartitioningStrategyConfig(PartitioningStrategyConfig partitioningStrategyConfig)`
    `MapConfig` | `setPartitionLostListenerConfigs(List<MapPartitionLostListenerConfig> listenerConfigs)`
    `void` | `setQueryCacheConfigs(List<QueryCacheConfig> queryCacheConfigs)` Sets `QueryCacheConfig` instances to this `MapConfig`.
    `MapConfig` | `setQuorumName(String quorumName)`
    `MapConfig` | `setReadBackupData(boolean readBackupData)` Sets read-backup-data (reading local backup entries) for this map.
    `MapConfig` | `setStatisticsEnabled(boolean statisticsEnabled)` Sets statistics to enabled or disabled for this map.
    `MapConfig` | `setTimeToLiveSeconds(int timeToLiveSeconds)` The maximum number of seconds for each entry to stay in the map.
    `MapConfig` | `setWanReplicationRef(WanReplicationRef wanReplicationRef)` Sets the WAN target replication reference.
    `String` | `toString()`
    `void` | `writeData(ObjectDataOutput out)` Writes object fields to output stream

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### MIN_BACKUP_COUNT

          public static final int MIN_BACKUP_COUNT

      The minimum number of backups
      See Also:
        Constant Field Values

    - #### DEFAULT_BACKUP_COUNT

          public static final int DEFAULT_BACKUP_COUNT

      The default number of backups
      See Also:
        Constant Field Values

    - #### MAX_BACKUP_COUNT

          public static final int MAX_BACKUP_COUNT

      The maximum number of backups
      See Also:
        Constant Field Values

    - #### MIN_EVICTION_PERCENTAGE

          public static final int MIN_EVICTION_PERCENTAGE

      The number of minimum eviction percentage
      See Also:
        Constant Field Values

    - #### DEFAULT_EVICTION_PERCENTAGE

          public static final int DEFAULT_EVICTION_PERCENTAGE

      The number of default eviction percentage
      See Also:
        Constant Field Values

    - #### MAX_EVICTION_PERCENTAGE

          public static final int MAX_EVICTION_PERCENTAGE

      The number of maximum eviction percentage
      See Also:
        Constant Field Values

    - #### DEFAULT_MIN_EVICTION_CHECK_MILLIS

          public static final long DEFAULT_MIN_EVICTION_CHECK_MILLIS

      Minimum time in milliseconds which should pass before asking if a partition of this map is evictable or not.
      See Also:
        Constant Field Values

    - #### DEFAULT_TTL_SECONDS

          public static final int DEFAULT_TTL_SECONDS

      The number of default Time to Live in seconds.
      See Also:
        Constant Field Values

    - #### DEFAULT_MAX_IDLE_SECONDS

          public static final int DEFAULT_MAX_IDLE_SECONDS

      The number of default time to wait eviction in seconds.
      See Also:
        Constant Field Values

    - #### DEFAULT_EVICTION_POLICY

          public static final EvictionPolicy DEFAULT_EVICTION_POLICY

      Default policy for eviction.

    - #### DEFAULT_MAP_MERGE_POLICY

          public static final String DEFAULT_MAP_MERGE_POLICY

      Default policy for merging.

    - #### DEFAULT_IN_MEMORY_FORMAT

          public static final InMemoryFormat DEFAULT_IN_MEMORY_FORMAT

      Default In-Memory format is binary.

    - #### DEFAULT_CACHED_DESERIALIZED_VALUES

          public static final CacheDeserializedValues DEFAULT_CACHED_DESERIALIZED_VALUES

      We want to cache values only when an index is defined.

    - #### DEFAULT_METADATA_POLICY

          public static final MetadataPolicy DEFAULT_METADATA_POLICY

      Default metadata policy

  - ### Constructor Detail

    - #### MapConfig

          public MapConfig()

    - #### MapConfig

          public MapConfig(String name)

    - #### MapConfig

          public MapConfig(MapConfig config)

  - ### Method Detail

    - #### getAsReadOnly

          public MapConfigReadOnly getAsReadOnly()

      Deprecated. this method will be removed in 4.0; it is meant for internal usage only
      Gets immutable version of this configuration.
      Returns:
        immutable version of this configuration

    - #### getName

          public String getName()

      Returns the name of this `IMap`
      Specified by:
        `getName` in interface `NamedConfig`
      Returns:
        the name of the `IMap`

    - #### setName

          public MapConfig setName(String name)

      Sets the name of the `IMap`
      Specified by:
        `setName` in interface `NamedConfig`
      Parameters:
        `name` - the name to set for this `IMap`

    - #### getInMemoryFormat

          public InMemoryFormat getInMemoryFormat()

      Returns the data type that will be used for storing records.
      Returns:
        data type that will be used for storing records

    - #### setInMemoryFormat

          public MapConfig setInMemoryFormat(InMemoryFormat inMemoryFormat)

      Binary type that will be used for storing records. Possible values:
      - BINARY (default): keys and values will be stored as binary data
      - OBJECT: values will be stored in their object forms
      - NATIVE: values will be stored in non-heap region of JVM
      Parameters:
        `inMemoryFormat` - the record type to set for this `IMap`
      Throws:
        `IllegalArgumentException` - if inMemoryFormat is `null`

    - #### getBackupCount

          public int getBackupCount()

      Returns the backupCount for this `IMap`
      Returns:
        the backupCount for this `IMap`
      See Also:
        `getAsyncBackupCount()`

    - #### setBackupCount

          public MapConfig setBackupCount(int backupCount)

      Number of synchronous backups. For example, if 1 is set as the backup count, then all entries of the map will be copied to another JVM for fail-safety. 0 means no sync backup.
      Parameters:
        `backupCount` - the number of synchronous backups to set for this `IMap`
      See Also:
        `setAsyncBackupCount(int)`

    - #### getAsyncBackupCount

          public int getAsyncBackupCount()

      Returns the asynchronous backup count for this `IMap`.
      Returns:
        the asynchronous backup count
      See Also:
        `setBackupCount(int)`

    - #### setAsyncBackupCount

          public MapConfig setAsyncBackupCount(int asyncBackupCount)

      Sets the number of asynchronous backups. 0 means no backups.
      Parameters:
        `asyncBackupCount` - the number of asynchronous synchronous backups to set
      Returns:
        the updated CacheConfig
      Throws:
        `IllegalArgumentException` - if asyncBackupCount smaller than 0, or larger than the maximum number of backup or the sum of the backups and async backups is larger than the maximum number of backups
      See Also:
        `setBackupCount(int)`, `getAsyncBackupCount()`

    - #### getTotalBackupCount

          public int getTotalBackupCount()

      Returns the total number of backups: backupCount plus asyncBackupCount.
      Returns:
        the total number of backups: synchronous + asynchronous

    - #### getEvictionPercentage

          @Deprecated
          public int getEvictionPercentage()

      Deprecated. As of version 3.7, eviction mechanism changed. It uses a probabilistic algorithm based on sampling. Please see documentation for further details.
      Returns the evictionPercentage: specified percentage of the map to be evicted.
      Returns:
        the evictionPercentage: specified percentage of the map to be evicted

    - #### setEvictionPercentage

          public MapConfig setEvictionPercentage(int evictionPercentage)

      Deprecated. As of version 3.7, eviction mechanism changed. It uses a probabilistic algorithm based on sampling. Please see documentation for further details
      When maximum size is reached, the specified percentage of the map will be evicted. Any integer between 0 and 100 is allowed. For example, if 25 is set, 25% of the entries will be evicted.

      Beware that eviction mechanism is different for NATIVE in-memory format (It uses a probabilistic algorithm based on sampling. Please see documentation for further details) and this parameter has no effect.

      Parameters:
        `evictionPercentage` - the evictionPercentage to set: the specified percentage of the map to be evicted
      Throws:
        `IllegalArgumentException` - if evictionPercentage is not in the 0-100 range

    - #### getMinEvictionCheckMillis

          public long getMinEvictionCheckMillis()

      Deprecated. As of version 3.7, eviction mechanism changed. It uses a probabilistic algorithm based on sampling. Please see documentation for further details.
      Returns the minimum milliseconds which should pass before asking if a partition of this map is evictable or not.

      Default value is 100L milliseconds.

      Returns:
        number of milliseconds that should pass before asking for the next eviction
      Since:
        3.3

    - #### setMinEvictionCheckMillis

          public MapConfig setMinEvictionCheckMillis(long minEvictionCheckMillis)

      Deprecated. As of version 3.7, eviction mechanism changed. It uses a probabilistic algorithm based on sampling. Please see documentation for further details.
      Sets the minimum time in milliseconds which should pass before asking if a partition of this map is evictable or not.

      Default value is 100L milliseconds.

      Beware that eviction mechanism is different for NATIVE in-memory format (It uses a probabilistic algorithm based on sampling. Please see documentation for further details) and this parameter has no effect.

      Parameters:
        `minEvictionCheckMillis` - time in milliseconds that should pass before asking for the next eviction
      Since:
        3.3

    - #### getTimeToLiveSeconds

          public int getTimeToLiveSeconds()

      Returns the maximum number of seconds for each entry to stay in the map.
      Returns:
        the maximum number of seconds for each entry to stay in the map

    - #### setTimeToLiveSeconds

          public MapConfig setTimeToLiveSeconds(int timeToLiveSeconds)

      The maximum number of seconds for each entry to stay in the map. Entries that are older than timeToLiveSeconds will be automatically evicted from the map. Updates on the entry will change the eviction time. Any integer between 0 and Integer.MAX_VALUE. 0 means infinite. Default is 0.
      Parameters:
        `timeToLiveSeconds` - the timeToLiveSeconds to set

    - #### getMaxIdleSeconds

          public int getMaxIdleSeconds()

      Returns the maximum number of seconds for each entry to stay idle in the map.
      Returns:
        the maximum number of seconds for each entry to stay idle in the map

    - #### setMaxIdleSeconds

          public MapConfig setMaxIdleSeconds(int maxIdleSeconds)

      Maximum number of seconds for each entry to stay idle in the map. Entries that are idle (not touched) for more than `maxIdleSeconds` will get automatically evicted from the map. Entry is touched if `get()`, `getAll()`, `put()` or `containsKey()` is called. Any integer between `0` and `Integer.MAX_VALUE`. `0` means infinite. Default is `0`. The time precision is limited by 1 second. The MaxIdle that less than 1 second can lead to unexpected behaviour.
      Parameters:
        `maxIdleSeconds` - the maxIdleSeconds (the maximum number of seconds for each entry to stay idle in the map) to set

    - #### getMaxSizeConfig

          public MaxSizeConfig getMaxSizeConfig()

    - #### setMaxSizeConfig

          public MapConfig setMaxSizeConfig(MaxSizeConfig maxSizeConfig)

    - #### getEvictionPolicy

          public EvictionPolicy getEvictionPolicy()

      Returns the `EvictionPolicy`.
      Returns:
        the evictionPolicy

    - #### setEvictionPolicy

          public MapConfig setEvictionPolicy(EvictionPolicy evictionPolicy)

      Sets the `EvictionPolicy`. Default value is `EvictionPolicy.NONE`.
      Parameters:
        `evictionPolicy` - the evictionPolicy to set

    - #### getMapEvictionPolicy

          public MapEvictionPolicy getMapEvictionPolicy()

      Returns custom eviction policy if it is set otherwise returns `null`.
      Returns:
        custom eviction policy or `null`

    - #### setMapEvictionPolicy

          public MapConfig setMapEvictionPolicy(MapEvictionPolicy mapEvictionPolicy)

      Sets custom eviction policy implementation for this map.

      Internal eviction algorithm finds most appropriate entry to evict from this map by using supplied policy.

      Parameters:
        `mapEvictionPolicy` - custom eviction policy implementation
      Returns:
        the updated map configuration

    - #### getMapStoreConfig

          public MapStoreConfig getMapStoreConfig()

      Returns the map store configuration
      Returns:
        the mapStoreConfig (map store configuration)

    - #### setMapStoreConfig

          public MapConfig setMapStoreConfig(MapStoreConfig mapStoreConfig)

      Sets the map store configuration
      Parameters:
        `mapStoreConfig` - the mapStoreConfig (map store configuration) to set

    - #### getNearCacheConfig

          public NearCacheConfig getNearCacheConfig()

      Returns the Near Cache configuration
      Returns:
        the Near Cache configuration

    - #### setNearCacheConfig

          public MapConfig setNearCacheConfig(NearCacheConfig nearCacheConfig)

      Sets the Near Cache configuration
      Parameters:
        `nearCacheConfig` - the Near Cache configuration
      Returns:
        the updated map configuration

    - #### getMergePolicy

          public String getMergePolicy()

      Deprecated. since 3.10, please use `getMergePolicyConfig()` and `MergePolicyConfig.getPolicy()`
      Gets the merge policy.
      Returns:
        the merge policy classname

    - #### setMergePolicy

          public MapConfig setMergePolicy(String mergePolicy)

      Deprecated. since 3.10, please use `setMergePolicyConfig(MergePolicyConfig)`
      Sets the merge policy.

      Accepts a classname of `SplitBrainMergePolicy` or the deprecated `MapMergePolicy`.

      Parameters:
        `mergePolicy` - the merge policy classname to set
      Returns:
        the updated map configuration

    - #### getMergePolicyConfig

          public MergePolicyConfig getMergePolicyConfig()

      Gets the `MergePolicyConfig` for this map.
      Returns:
        the `MergePolicyConfig` for this map

    - #### setMergePolicyConfig

          public MapConfig setMergePolicyConfig(MergePolicyConfig mergePolicyConfig)

      Sets the `MergePolicyConfig` for this map.
      Returns:
        the updated map configuration

    - #### getProvidedMergeTypes

          public Class getProvidedMergeTypes()

      Specified by:
        `getProvidedMergeTypes` in interface `SplitBrainMergeTypeProvider`

    - #### isStatisticsEnabled

          public boolean isStatisticsEnabled()

      Checks if statistics are enabled for this map.
      Returns:
        `true` if statistics are enabled, `false` otherwise

    - #### setStatisticsEnabled

          public MapConfig setStatisticsEnabled(boolean statisticsEnabled)

      Sets statistics to enabled or disabled for this map.
      Parameters:
        `statisticsEnabled` - `true` to enable map statistics, `false` to disable
      Returns:
        the current map config instance

    - #### isReadBackupData

          public boolean isReadBackupData()

      Checks if read-backup-data (reading local backup entries) is enabled for this map.
      Returns:
        `true` if read-backup-data is enabled, `false` otherwise

    - #### setReadBackupData

          public MapConfig setReadBackupData(boolean readBackupData)

      Sets read-backup-data (reading local backup entries) for this map.
      Parameters:
        `readBackupData` - `true` to enable read-backup-data, `false` to disable
      Returns:
        the current map config instance

    - #### getWanReplicationRef

          public WanReplicationRef getWanReplicationRef()

      Gets the WAN target replication reference.
      Returns:
        the WAN target replication reference

    - #### setWanReplicationRef

          public MapConfig setWanReplicationRef(WanReplicationRef wanReplicationRef)

      Sets the WAN target replication reference.
      Parameters:
        `wanReplicationRef` - the WAN target replication reference
      Returns:
        the current map config instance

    - #### addEntryListenerConfig

          public MapConfig addEntryListenerConfig(EntryListenerConfig listenerConfig)

    - #### getEntryListenerConfigs

          public List<EntryListenerConfig> getEntryListenerConfigs()

    - #### setEntryListenerConfigs

          public MapConfig setEntryListenerConfigs(List<EntryListenerConfig> listenerConfigs)

    - #### addMapPartitionLostListenerConfig

          public MapConfig addMapPartitionLostListenerConfig(MapPartitionLostListenerConfig listenerConfig)

    - #### getPartitionLostListenerConfigs

          public List<MapPartitionLostListenerConfig> getPartitionLostListenerConfigs()

    - #### setPartitionLostListenerConfigs

          public MapConfig setPartitionLostListenerConfigs(List<MapPartitionLostListenerConfig> listenerConfigs)

    - #### addMapIndexConfig

          public MapConfig addMapIndexConfig(MapIndexConfig mapIndexConfig)

    - #### getMapIndexConfigs

          public List<MapIndexConfig> getMapIndexConfigs()

    - #### setMapIndexConfigs

          public MapConfig setMapIndexConfigs(List<MapIndexConfig> mapIndexConfigs)

    - #### addMapAttributeConfig

          public MapConfig addMapAttributeConfig(MapAttributeConfig mapAttributeConfig)

    - #### getMapAttributeConfigs

          public List<MapAttributeConfig> getMapAttributeConfigs()

    - #### setMapAttributeConfigs

          public MapConfig setMapAttributeConfigs(List<MapAttributeConfig> mapAttributeConfigs)

    - #### getMetadataPolicy

          public MetadataPolicy getMetadataPolicy()

      Returns `MetadataPolicy` for this map.
      Returns:
        `MetadataPolicy` for this map

    - #### setMetadataPolicy

          public MapConfig setMetadataPolicy(MetadataPolicy metadataPolicy)

      Sets the metadata policy. See `MetadataPolicy` for more information.
      Parameters:
        `metadataPolicy` -

    - #### addQueryCacheConfig

          public MapConfig addQueryCacheConfig(QueryCacheConfig queryCacheConfig)

      Adds a new `QueryCacheConfig` to this `MapConfig`.
      Parameters:
        `queryCacheConfig` - the config to be added
      Returns:
        this `MapConfig` instance
      Throws:
        `IllegalArgumentException` - if there is already a `QueryCache` with the same `QueryCacheConfig#name`

    - #### getQueryCacheConfigs

          public List<QueryCacheConfig> getQueryCacheConfigs()

      Returns all `QueryCacheConfig` instances defined on this `MapConfig`.
      Returns:
        all `QueryCacheConfig` instances defined on this `MapConfig`

    - #### setQueryCacheConfigs

          public void setQueryCacheConfigs(List<QueryCacheConfig> queryCacheConfigs)

      Sets `QueryCacheConfig` instances to this `MapConfig`.

    - #### getPartitioningStrategyConfig

          public PartitioningStrategyConfig getPartitioningStrategyConfig()

    - #### setPartitioningStrategyConfig

          public MapConfig setPartitioningStrategyConfig(PartitioningStrategyConfig partitioningStrategyConfig)

    - #### isNearCacheEnabled

          public boolean isNearCacheEnabled()

      Checks if Near Cache is enabled.
      Returns:
        `true` if Near Cache is enabled, `false` otherwise

    - #### isOptimizeQueries

          public boolean isOptimizeQueries()

      Deprecated. use `getQueryCacheConfigs()` instead
      Checks if queries are optimized.
      Returns:
        `true` if queries are optimized, `false` otherwise

    - #### setOptimizeQueries

          public MapConfig setOptimizeQueries(boolean optimizeQueries)

      Deprecated. use `setCacheDeserializedValues(CacheDeserializedValues)` instead
      Enable de-serialized value caching when evaluating predicates. It has no effect when `InMemoryFormat` is `InMemoryFormat.OBJECT` or when `Portable` serialization is used.
      Parameters:
        `optimizeQueries` - `true` if queries should be optimized, `false` otherwise
      Returns:
        this `MapConfig` instance
      See Also:
        `CacheDeserializedValues`

    - #### setCacheDeserializedValues

          public MapConfig setCacheDeserializedValues(CacheDeserializedValues cacheDeserializedValues)

      Configure de-serialized value caching. Default: `CacheDeserializedValues.INDEX_ONLY`
      Returns:
        this `MapConfig` instance
      Since:
        3.6
      See Also:
        `CacheDeserializedValues`

    - #### getHotRestartConfig

          public HotRestartConfig getHotRestartConfig()

      Gets the `HotRestartConfig` for this `MapConfig`
      Returns:
        hot restart config

    - #### setHotRestartConfig

          public MapConfig setHotRestartConfig(HotRestartConfig hotRestartConfig)

      Sets the `HotRestartConfig` for this `MapConfig`
      Parameters:
        `hotRestartConfig` - hot restart config
      Returns:
        this `MapConfig` instance

    - #### getCacheDeserializedValues

          public CacheDeserializedValues getCacheDeserializedValues()

      Get current value cache settings
      Returns:
        current value cache settings
      Since:
        3.6

    - #### getQuorumName

          public String getQuorumName()

    - #### setQuorumName

          public MapConfig setQuorumName(String quorumName)

    - #### equals

          public final boolean equals(Object o)

      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public final int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### getFactoryId

          public int getFactoryId()

      Description copied from interface: `IdentifiedDataSerializable`
      Returns DataSerializableFactory factory ID for this class.
      Specified by:
        `getFactoryId` in interface `IdentifiedDataSerializable`
      Returns:
        factory ID

    - #### getId

          public int getId()

      Description copied from interface: `IdentifiedDataSerializable`
      Returns type identifier for this class. It should be unique per DataSerializableFactory.
      Specified by:
        `getId` in interface `IdentifiedDataSerializable`
      Returns:
        type ID

    - #### writeData

          public void writeData(ObjectDataOutput out)
                         throws IOException

      Description copied from interface: `DataSerializable`
      Writes object fields to output stream
      Specified by:
        `writeData` in interface `DataSerializable`
      Parameters:
        `out` - output
      Throws:
        `IOException` - if an I/O error occurs. In particular, an `IOException` may be thrown if the output stream has been closed.

    - #### readData

          public void readData(ObjectDataInput in)
                        throws IOException

      Description copied from interface: `DataSerializable`
      Reads fields from the input stream
      Specified by:
        `readData` in interface `DataSerializable`
      Parameters:
        `in` - input
      Throws:
        `IOException` - if an I/O error occurs. In particular, an `IOException` may be thrown if the input stream has been closed.

Copyright © 2019. All rights reserved.